diff a/test/micro/org/openjdk/bench/valhalla/array/fill/InlineOpt.java b/test/micro/org/openjdk/bench/valhalla/array/fill/InlineOpt.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/fill/InlineOpt.java
@@ -0,0 +1,238 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.fill;
+
+import org.openjdk.bench.valhalla.array.util.StatesQOpt;
+import org.openjdk.bench.valhalla.types.Int32;
+import org.openjdk.bench.valhalla.types.QOpt;
+import org.openjdk.bench.valhalla.types.R32int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.State;
+
+import java.util.Arrays;
+
+public class InlineOpt extends StatesQOpt {
+
+    public static class RefStaticField {
+        static QOpt<Int32> f = QOpt.of(new R32int(42));
+    }
+
+    public static class ValStaticField {
+        static QOpt<Int32> f = QOpt.of(new R32int(42));
+    }
+
+    @State(Scope.Thread)
+    public static class RefInstanceField {
+        QOpt<Int32> f = QOpt.of(new R32int(42));
+    }
+
+    @State(Scope.Thread)
+    public static class ValInstanceField {
+        QOpt<Int32> f = QOpt.of(new R32int(42));
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Def_to_Val_as_Val_fill(Val_as_Val st) {
+        QOpt<Int32>[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = QOpt.of();
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Val_as_Val_fill(Val_as_Val st) {
+        QOpt<Int32>[] arr = st.arr;
+        QOpt<Int32> v = QOpt.of(new R32int(42));
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = v;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_as_Val_fillstat(Val_as_Val st) {
+        QOpt<Int32>[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = RefStaticField.f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_as_Val_fillstat(Val_as_Val st) {
+        QOpt<Int32>[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = ValStaticField.f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_as_Val_fillinst(Val_as_Val st, RefInstanceField f) {
+        QOpt<Int32>[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = f.f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_as_Val_fillinst(Val_as_Val st, ValInstanceField f) {
+        QOpt<Int32>[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = f.f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Def_to_Ref_as_Ref_fill(Ref_as_Ref st) {
+        QOpt<Int32>[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = QOpt.of();
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Ref_as_Ref_fill(Ref_as_Ref st) {
+        QOpt<Int32>[] arr = st.arr;
+        QOpt<Int32> v = QOpt.of(new R32int(42));
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = v;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Ref_as_Ref_fillstat(Ref_as_Ref st) {
+        QOpt<Int32>[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = RefStaticField.f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_as_Ref_fillstat(Ref_as_Ref st) {
+        QOpt<Int32>[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = ValStaticField.f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Ref_as_Ref_fillinst(Ref_as_Ref st, RefInstanceField f) {
+        QOpt<Int32>[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = f.f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_as_Ref_fillinst(Ref_as_Ref st, ValInstanceField f) {
+        QOpt<Int32>[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = f.f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Def_to_Val_as_Val_arrayfill(Val_as_Val st) {
+        Arrays.fill(st.arr, QOpt.of() );
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Val_as_Val_arrayfill(Val_as_Val st) {
+        Arrays.fill(st.arr, QOpt.of(new R32int(42)));
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_as_Val_arrayfillstat(Val_as_Val st) {
+        Arrays.fill(st.arr, RefStaticField.f);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_as_Val_arrayfillstat(Val_as_Val st) {
+        Arrays.fill(st.arr, ValStaticField.f);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_as_Val_arrayfillinst(Val_as_Val st, RefInstanceField f) {
+        Arrays.fill(st.arr, f.f);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_as_Val_arrayfillinst(Val_as_Val st, ValInstanceField f) {
+        Arrays.fill(st.arr, f.f);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Def_to_Ref_as_Ref_arrayfill(Ref_as_Ref st) {
+        Arrays.fill(st.arr, QOpt.of()  );
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Ref_as_Ref_arrayfill(Ref_as_Ref st) {
+        Arrays.fill(st.arr, QOpt.of(new R32int(42)));
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Ref_as_Ref_arrayfillstat(Ref_as_Ref st) {
+        Arrays.fill(st.arr, RefStaticField.f);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_as_Ref_arrayfillstat(Ref_as_Ref st) {
+        Arrays.fill(st.arr, ValStaticField.f);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Ref_as_Ref_arrayfillinst(Ref_as_Ref st, RefInstanceField f) {
+        Arrays.fill(st.arr, f.f);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_as_Ref_arrayfillinst(Ref_as_Ref st, ValInstanceField f) {
+        Arrays.fill(st.arr, f.f);
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/fill/Primitive64.java b/test/micro/org/openjdk/bench/valhalla/array/fill/Primitive64.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/fill/Primitive64.java
@@ -0,0 +1,58 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.fill1;
+
+import org.openjdk.bench.valhalla.array.util.PrimitiveStates;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+import java.util.Arrays;
+
+public class Primitive64 extends PrimitiveStates {
+
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void fill0(Primitive64long st) {
+        long[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = 42;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void fill1(Primitive64long st) {
+        int len = st.arr.length;
+        for (int i = 0; i < len; i++) {
+            st.arr[i] = 42;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void arrayfill(Primitive64long st) {
+        Arrays.fill(st.arr, 42);
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/read/Inline128int.java b/test/micro/org/openjdk/bench/valhalla/array/read/Inline128int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/read/Inline128int.java
@@ -0,0 +1,108 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.read;
+
+import org.openjdk.bench.valhalla.array.util.StatesQ128int;
+import org.openjdk.bench.valhalla.types.Int128;
+import org.openjdk.bench.valhalla.types.Q128int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline128int extends StatesQ128int {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void val_consume(Q128int v) {
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void ref_consume(Q128int v) {
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void int_consume(Int128 v) {
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Val_to_Val_read(Val_as_Val st) {
+        Q128int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Val_to_Ref_read(Val_as_Val st) {
+        Q128int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            ref_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Val_to_Int_read(Val_as_Val st) {
+        Q128int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            int_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Ref_to_Val_read(Val_as_Ref st) {
+        Q128int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Ref_to_Ref_read(Val_as_Ref st) {
+        Q128int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            ref_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Ref_to_Int_read(Val_as_Ref st) {
+        Q128int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            int_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Int_to_Int_read(Val_as_Int st) {
+        Int128[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            int_consume(arr[i]);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/read/Inline32int.java b/test/micro/org/openjdk/bench/valhalla/array/read/Inline32int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/read/Inline32int.java
@@ -0,0 +1,108 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.read;
+
+import org.openjdk.bench.valhalla.array.util.StatesQ32int;
+import org.openjdk.bench.valhalla.types.Int32;
+import org.openjdk.bench.valhalla.types.Q32int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline32int extends StatesQ32int {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void val_consume(Q32int v) {
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void ref_consume(Q32int v) {
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void int_consume(Int32 v) {
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Val_to_Val_read(Val_as_Val st) {
+        Q32int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Val_to_Ref_read(Val_as_Val st) {
+        Q32int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            ref_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Val_to_Int_read(Val_as_Val st) {
+        Q32int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            int_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Ref_to_Val_read(Val_as_Ref st) {
+        Q32int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Ref_to_Ref_read(Val_as_Ref st) {
+        Q32int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            ref_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Ref_to_Int_read(Val_as_Ref st) {
+        Q32int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            int_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Int_to_Int_read(Val_as_Int st) {
+        Int32[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            int_consume(arr[i]);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/read/Inline64byte.java b/test/micro/org/openjdk/bench/valhalla/array/read/Inline64byte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/read/Inline64byte.java
@@ -0,0 +1,108 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.read;
+
+import org.openjdk.bench.valhalla.array.util.StatesQ64byte;
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64byte;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline64byte extends StatesQ64byte {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void val_consume(Q64byte v) {
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void ref_consume(Q64byte v) {
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void int_consume(Int64 v) {
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Val_to_Val_read(Val_as_Val st) {
+        Q64byte[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Val_to_Ref_read(Val_as_Val st) {
+        Q64byte[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            ref_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Val_to_Int_read(Val_as_Val st) {
+        Q64byte[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            int_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Ref_to_Val_read(Val_as_Ref st) {
+        Q64byte[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Ref_to_Ref_read(Val_as_Ref st) {
+        Q64byte[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            ref_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Ref_to_Int_read(Val_as_Ref st) {
+        Q64byte[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            int_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Int_to_Int_read(Val_as_Int st) {
+        Int64[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            int_consume(arr[i]);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/read/Inline64int.java b/test/micro/org/openjdk/bench/valhalla/array/read/Inline64int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/read/Inline64int.java
@@ -0,0 +1,108 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.read;
+
+import org.openjdk.bench.valhalla.array.util.StatesQ64int;
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline64int extends StatesQ64int {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void val_consume(Q64int v) {
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void ref_consume(Q64int v) {
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void int_consume(Int64 v) {
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Val_to_Val_read(Val_as_Val st) {
+        Q64int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Val_to_Ref_read(Val_as_Val st) {
+        Q64int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            ref_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Val_to_Int_read(Val_as_Val st) {
+        Q64int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            int_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Ref_to_Val_read(Val_as_Ref st) {
+        Q64int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Ref_to_Ref_read(Val_as_Ref st) {
+        Q64int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            ref_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Ref_to_Int_read(Val_as_Ref st) {
+        Q64int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            int_consume(arr[i]);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_as_Int_to_Int_read(Val_as_Int st) {
+        Int64[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            int_consume(arr[i]);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/read/Primitive128int.java b/test/micro/org/openjdk/bench/valhalla/array/read/Primitive128int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/read/Primitive128int.java
@@ -0,0 +1,44 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.read;
+
+import org.openjdk.bench.valhalla.array.util.PrimitiveStates;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Primitive128int extends PrimitiveStates {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void consume_int(int v0, int v1, int v2, int v3) {
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void p128int_read(Primitive128int st) {
+        int[] values = st.arr;
+        for (int i = 0; i < values.length; i+=4) {
+            consume_int(values[i], values[i+1], values[i+2], values[i+3]);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/read/Primitive32int.java b/test/micro/org/openjdk/bench/valhalla/array/read/Primitive32int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/read/Primitive32int.java
@@ -0,0 +1,44 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.read;
+
+import org.openjdk.bench.valhalla.array.util.PrimitiveStates;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Primitive32int extends PrimitiveStates {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void consume_int(int v) {
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void p32int_read(Primitive32int st) {
+        int[] values = st.arr;
+        for (int i = 0; i < values.length; i++) {
+            consume_int(values[i]);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/read/Primitive64byte.java b/test/micro/org/openjdk/bench/valhalla/array/read/Primitive64byte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/read/Primitive64byte.java
@@ -0,0 +1,44 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.read;
+
+import org.openjdk.bench.valhalla.array.util.PrimitiveStates;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Primitive64byte extends PrimitiveStates {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void consume_byte(byte v0, byte v1, byte v2, byte v3, byte v4, byte v5, byte v6, byte v7) {
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void p64byte_read(Primitive64byte st) {
+        byte[] values = st.arr;
+        for (int i = 0; i < values.length; i+=8) {
+            consume_byte(values[i], values[i+1], values[i+2], values[i+3], values[i+4], values[i+5], values[i+6], values[i+7]);
+        }
+    }
+
+}
